NB. Script ras_tile.ijs
NB. Used to create enhanced Voronoi tilings
NB. by Ned Allis, Jeffrey Dumont and Cliff Reiter
NB. July 27, 2000
NB. Updated for J5.01a and Image3 addon, 
NB. October 2002
NB. Run the ras_tile2.ijt Lab to see the
NB. facilities in action

require'addons\image3\view_m.ijs'

NB. for superpixels
spix=: [#"1#     NB. for superpixel replication

NB. Coloring Palettes
R254=:0,255,~Hue 5r6*(i.%<:)254

NB. for the Sierpinski triangle construcrion
siertri=: ,,.~

NB. Utilities for constructing Figures/Tables in paper
Ld=:|.j.~/~i:1            NB. Local displacement matrix
perext=:{:,],{.
perext2=:perext"1@:perext
ldispl=:((=<./)@:|{.@#])@,@(-&Ld)
displ_step=:3 3&(ldispl;._3)@perext2
displ=:displ_step^:_                    NB. complex displacement
mag2=:* +                               NB. square of magnitude
vor=: (2: <: 4&{ +/ . >: -:@+/@:((0 _1+(,:-)i.4)&{))@,
voronoi=:3 3&(vor;._3)@perext2          NB. Boolean giving Voronoi tiles
lnegspred=:((4&{ <: 0:){4&{,<./)@,      NB. local negative spred
negspred=:3 3&(lnegspred;._3)@perext2   NB. integer
lauto=: {~ #.                           NB. local automata
lseal=:(1(6)}8#i.2) &lauto @,
hseal=: 2 2&( lseal ;._3) @:(,{.)@:((,{.)"1)
seal=:|."1@:hseal@:(|."1)@:hseal        NB. fills thin staircases

NB. Other utilities
flu=: (+._1&|.)
fluf=: flu"1@:flu
sfluf=: (**]>._1&|.)@:(**]>.1&|.)"1@:(**]>._1&|.)@:(**]>.1&|.)^:_@:(i.@$*])
fluff=:sfluf@:fluf
cen2=: i.&1 + i:&1
cen=:# | [: <.@-: cen2`(# + cen2@:-.)@.{.
center=: cen@:(+./"1) , cen@:(+./)
fclean=:3 : '1(<"1(-.&0@:~.@:, center@:="0 _ ]) sfluf fluf y.)}($y.)$0'

NB. utility for linear height coloring
lin254b=: 3 : 0
min=.<./(>&0#]),y.
max=.>./,y.
(y.>0)*1+<.(253.999%(max-min))*y.-min
)

NB. Make four standard images 
NB. [superpixel_size] data vor_pngs 'fileprefix'
vor_pngs=: 1 : 0
2 m. vor_pngs y.
:
ver=:m.
(R254;255*-.x. spix m.) write_image  y.,'_ver.png'
dp=: displ 1000*-.m.
dp2=:mag2 dp
(P256;x. spix 256 cile dp2) write_image  y.,'_mag.png'
vo=:seal voronoi dp2
(R254;255*-.x. spix vo) write_image  y.,'_vor.png'
til=:negspred^:_ vo+(-.vo)*->:dp2
(R254;x. spix (255*m.)>. lin254b %:-.til) write_image  y.,'_til.png'
)

